<?php

class SEARCHResults {
 var $results;
 var $current;		// Current module, we are adding results in
 
 function __construct($module = false) {
    $this->results = array();
    $this->current = false;
    if ($module) $this->NewModule($module);
 }

 function AcceptCurrent() {
    if ($this->current) {
	if (!sizeof($this->results[$this->current]['results'])) {
	    unset($this->results[$this->current]);
	}
    }
    
    $this->current = false;
 }

 function HaveResults() {
    $this->AcceptCurrent();
    if (sizeof($this->results)>0) return true;
    return false;
 }
 
 function NewModule($module) {
    $data = array(
	'module' => $module,
	'title' => $this->modules[$module]['title'],
	'results' => array()
    );

    $this->results[$module] = $data;

    $this->AcceptCurrent();
    $this->current = $module;
 }
    
 function Append(&$info, $rating = 1, $key = false) {
    if ($this->current === false)
	throw new ADEIException("Internal Error: Addition of search results is failed, Unknown module");
	
    $info['rating'] = $rating;
    if ($key === false) {
	$this->results[$this->current]['results'][] = $info;
    } else {
	$this->results[$this->current]['results'][$key] = $info;
    }
 }
 
 function Combine(SEARCHResults $sr) {
    $this->AcceptCurrent();
    $sr->AcceptCurrent();
    
    $this->results = array_merge($this->results, $sr->results);
/*
    foreach ($sr->results as $mod => &$res) {
	$this->results[$mod] = $res;
    }
*/
 }
 
 function Intersect(SEARCHResults $sr) {
    throw new ADEIException("Intersection of search results is not implemented yet");
 }

 
 static function Merge() {
    $res = new SEARCHResults();
    
    for ($i = 0;$i < func_num_args();$i++) {
	$mres = func_get_arg($i);
	if ($mres instanceof SEARCHResults) {
	    $res->Combine($mres);
	} else if ($mres !== false) {
	    throw new ADEIException("Internal error: Only SEARCHResult could be merged");
	}
    }

    if ($res->HaveResults()) return $res;
    return false;
 }
}


?>