function XSLPOOL(cache) {
    if (typeof cache == "undefined") this.use_cache = false;
    this.use_cache = cache;
    
    this.cache = new Array();
}

XSLPOOL.prototype.ProcessXML = function(xmldoc, attr, error) {
    if (!xmldoc) {
	if (attr.handler) attr.handler(null, attr.attr, error);
	else adei.ReportError(error);
	return;
    }
    
    if (attr.handler) {
	var htmldoc = xsltApply(attr.xsltdoc, xmldoc);
	attr.handler(htmldoc, attr.attr);
    } else {
	xsltApply(attr.xsltdoc, xmldoc, attr.attr);
    }
}

XSLPOOL.prototype.ApplyXSLT = function(xsltdoc, xmlurl, handler, attr) {
    var xattr = new Object;

    xattr.self = this;
    xattr.handler = handler;
    xattr.attr = attr;
    xattr.xsltdoc = xsltdoc;
    
    if (typeof xmlurl == "object") {
	this.ProcessXML(xmlurl, xattr);
    } else {
	loadXML(xmlurl, 
	    function (xmldoc, attr, error) { 
		attr.self.ProcessXML(xmldoc, attr, error)
	    }, xattr);
    }
}

XSLPOOL.prototype.ProcessXSLT = function(xsltdoc, attr) {
    if (this.use_cache) {
	this.cache[attr.xslt] = xsltdoc;
    }
    
    return this.ApplyXSLT(xsltdoc, attr.xmlurl, attr.handler, attr.attr);
}

XSLPOOL.prototype.Load = function(xslt, xmlurl, handler, attr) {
    if (typeof this.cache[xslt] != "undefined") {
	return this.ApplyXSLT(this.cache[xslt], xmlurl, handler, attr);
    }
    
    var xattr = new Object;
    xattr.self = this;
    xattr.handler = handler;
    xattr.attr = attr;
    xattr.xslt = xslt;
    xattr.xmlurl = xmlurl;
    
    loadXSLT("xslt/" + xslt + ".xsl", 
	function (xsltdoc, self) { xattr.self.ProcessXSLT(xsltdoc, xattr) }, 
	xattr
    );

}
